
/*  A Bison parser, made from ./src/cg2tree.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	ID	257
#define	DOUBLEQOUTED	258
#define	SINGLEQOUTED	259
#define	REPLACE	260
#define	OR	261
#define	ENDRULES	262
#define	SUBST	263

#line 1 "./src/cg2tree.y"

#include <string>
#include <vector>
#include <errno.h>
#include <stdio.h>
#include "common.hh"
#include "Rule.hh"
#include "Regex.hh"
#include "Token.hh"
#include "Symbol.hh"
#include "debug.hh"
#include "compiler.hh"
#include "tokenizer.hh"
#include "SRNode.hh"
#include "RETree.hh"
  
  extern int errno;
  extern FILE * yyin;
  extern char yytext;
  extern int linie;
  int yylex();
  void yyerror(char *s)
    {
      cout << s << " in line " << linie << "\n";
    }
  int debugLevel;
  int reduce;
  int tree;
  int code;
  int parse;
  int experimental;
  int printComplete;
  int printIncompletable;
  int printAllStates;
  int tracking;
  int statistics;
  
  Rules * rules = new Rules();
  Synonyms * synonyms = new Synonyms();
  TokenString * input;
  TokenString * output;
  

#line 45 "./src/cg2tree.y"
typedef union 
{
  string * str;
  TagField * field;
  FormAndFunc * ff;
  Symbol * sym;
  RegExpr * expr;
  vector<Rule*> * rulelist;
  StringSet * set;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		66
#define	YYFLAG		-32768
#define	YYNTBASE	26

#define YYTRANSLATE(x) ((unsigned)(x) <= 263 ? yytranslate[x] : 40)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    13,     2,     2,     2,     2,     2,     2,    15,
    16,    17,    11,    23,     2,    14,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    20,    12,     2,
    10,     2,    18,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    24,     2,    25,     2,    19,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    21,     2,    22,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     5,     8,     9,    15,    21,    26,    31,    35,
    37,    40,    42,    46,    48,    52,    55,    58,    61,    65,
    67,    69,    73,    75,    78,    82,    84,    85,    89,    91,
    95,    97,    99,   103,   107,   109,   111,   116
};

static const short yyrhs[] = {    27,
     8,     0,    27,     0,    28,    27,     0,     0,    32,    10,
    11,    29,    12,     0,    32,    10,    13,    29,    12,     0,
    32,    10,    29,    12,     0,    32,     9,    32,    12,     0,
    29,     7,    30,     0,    30,     0,    30,    31,     0,    31,
     0,    32,    14,    37,     0,    32,     0,    15,    29,    16,
     0,    31,    17,     0,    31,    11,     0,    31,    18,     0,
    33,    19,    33,     0,    33,     0,    37,     0,    34,    20,
    34,     0,    34,     0,    35,    39,     0,    21,    36,    22,
     0,     3,     0,     0,     3,    23,    36,     0,     3,     0,
    21,    38,    22,     0,     4,     0,     5,     0,     4,    23,
    38,     0,     5,    23,    38,     0,     4,     0,     5,     0,
    24,     6,     3,    25,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    71,    77,    87,    92,   104,   112,   119,   126,   145,   151,
   163,   169,   184,   197,   207,   212,   217,   223,   237,   243,
   248,   262,   268,   275,   289,   295,   301,   313,   320,   336,
   342,   348,   365,   372,   378,   384,   398,   404
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","ID","DOUBLEQOUTED",
"SINGLEQOUTED","REPLACE","OR","ENDRULES","SUBST","'='","'+'","';'","'!'","'.'",
"'('","')'","'*'","'?'","'_'","':'","'{'","'}'","','","'['","']'","grammar",
"ruleset","rule","regex","term","factor","symbol","form_and_function","tag_field",
"set_of_tags","id_list","set_of_literals","lit_list","rewriter", NULL
};
#endif

static const short yyr1[] = {     0,
    26,    26,    27,    27,    28,    28,    28,    28,    29,    29,
    30,    30,    31,    31,    31,    31,    31,    31,    32,    32,
    32,    33,    33,    34,    35,    35,    35,    36,    36,    37,
    37,    37,    38,    38,    38,    38,    39,    39
};

static const short yyr2[] = {     0,
     2,     1,     2,     0,     5,     5,     4,     4,     3,     1,
     2,     1,     3,     1,     3,     2,     2,     2,     3,     1,
     1,     3,     1,     2,     3,     1,     0,     3,     1,     3,
     1,     1,     3,     3,     1,     1,     4,     0
};

static const short yydefact[] = {    27,
    26,    31,    32,     0,     2,    27,     0,    20,    23,    38,
    21,    29,    35,    36,     0,     0,     1,     3,    27,    27,
    27,    27,     0,    24,     0,     0,     0,    25,    30,     0,
    27,    27,    27,     0,    27,    12,    14,     0,    19,    22,
     0,    28,    33,    34,     8,     0,     0,     0,    27,     7,
    11,    17,    16,    18,     0,     0,     5,     6,    15,    27,
     0,    13,    37,     0,     0,     0
};

static const short yydefgoto[] = {    64,
     5,     6,    34,    35,    36,    37,     8,     9,    10,    15,
    11,    16,    24
};

static const short yypact[] = {     1,
-32768,-32768,-32768,    67,    -5,     1,    45,   -12,   -10,    12,
-32768,    -9,    34,    44,    29,    51,-32768,-32768,    13,    37,
    16,    16,    59,-32768,    78,    73,    73,-32768,-32768,    70,
    28,    28,    28,    54,     8,    42,    69,    78,-32768,-32768,
    81,-32768,-32768,-32768,-32768,    56,    57,    40,    28,-32768,
    42,-32768,-32768,-32768,    41,    60,-32768,-32768,-32768,    23,
    73,-32768,-32768,    86,    87,-32768
};

static const short yypgoto[] = {-32768,
    82,-32768,    43,    46,   -35,     2,    68,    71,-32768,    65,
    36,    53,-32768
};


#define	YYLAST		95


static const short yytable[] = {    51,
    -4,     7,    17,     1,     2,     3,    21,     7,    -4,    22,
     1,     2,     3,    25,   -10,     1,     2,     3,     1,   -10,
    30,     4,    33,   -10,    51,     1,     2,     3,     4,    -9,
     1,     2,     3,     4,    -9,    23,    38,    33,    -9,     1,
     2,     3,    33,     4,     2,     3,    49,    31,     4,    32,
    28,    33,    52,    19,    20,    59,    26,     4,    53,    54,
    49,    61,    49,    49,    41,    50,    27,    57,    58,    12,
    13,    14,    29,    46,    47,    48,    13,    14,    43,    44,
    12,    45,    55,    56,    63,    65,    66,    18,    39,    42,
    62,     0,    40,     0,    60
};

static const short yycheck[] = {    35,
     0,     0,     8,     3,     4,     5,    19,     6,     8,    20,
     3,     4,     5,    23,     7,     3,     4,     5,     3,    12,
    19,    21,    15,    16,    60,     3,     4,     5,    21,     7,
     3,     4,     5,    21,    12,    24,    21,    15,    16,     3,
     4,     5,    15,    21,     4,     5,     7,    11,    21,    13,
    22,    15,    11,     9,    10,    16,    23,    21,    17,    18,
     7,    21,     7,     7,     6,    12,    23,    12,    12,     3,
     4,     5,    22,    31,    32,    33,     4,     5,    26,    27,
     3,    12,    14,     3,    25,     0,     0,     6,    21,    25,
    55,    -1,    22,    -1,    49
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 73 "./src/cg2tree.y"
{
  rout << "grammar -> ruleset ENDRULES\n";
  YYACCEPT;
;
    break;}
case 2:
#line 79 "./src/cg2tree.y"
{
  rout << "grammar -> ruleset\n";
;
    break;}
case 3:
#line 89 "./src/cg2tree.y"
{
  rout << "ruleset -> rule ruleset\n";
;
    break;}
case 4:
#line 93 "./src/cg2tree.y"
{
  rout << "ruleset -> \n";
;
    break;}
case 5:
#line 106 "./src/cg2tree.y"
{
  rout << "rule -> symbol =+ regex ;\n";
  Rule * rule = new Rule(yyvsp[-4].sym,yyvsp[-1].expr,'+');
  rules->push_back(rule);
  debug(1) << rule->toString() << "\n";
;
    break;}
case 6:
#line 113 "./src/cg2tree.y"
{
  rout << "rule -> symbol =+ regex ;\n";
  Rule * rule = new Rule(yyvsp[-4].sym,yyvsp[-1].expr,'!');
  rules->push_back(rule);
  debug(1) << rule->toString() << "\n";
;
    break;}
case 7:
#line 120 "./src/cg2tree.y"
{
  rout << "rule -> symbol = regex ;\n";
  Rule * rule = new Rule(yyvsp[-3].sym,yyvsp[-1].expr,' ');
  rules->push_back(rule);
  debug(1) << rule->toString() << "\n";
;
    break;}
case 8:
#line 127 "./src/cg2tree.y"
{
  rout << "rule -> symbol <- symbol ;\n";
  Symbol * synonym = new Symbol
    (new TagField(yyvsp[-1].sym->funcs->tags,  yyvsp[-3].sym->funcs->first()),
     new TagField(yyvsp[-1].sym->forms->tags,  yyvsp[-3].sym->forms->first()),
     new TagField(yyvsp[-1].sym->sfuncs->tags, yyvsp[-3].sym->sfuncs->first()),
     new TagField(yyvsp[-1].sym->sforms->tags, yyvsp[-3].sym->sforms->first())
     );
  synonyms->push_back(synonym);
  debug(1) << synonym->toString() << "\n";
;
    break;}
case 9:
#line 147 "./src/cg2tree.y"
{
  rout << "regex -> regex || term\n";
  yyval.expr = new AlternationExpr(yyvsp[-2].expr, yyvsp[0].expr);
;
    break;}
case 10:
#line 152 "./src/cg2tree.y"
{
  rout << "regex -> term\n";
  yyval.expr = yyvsp[0].expr;
;
    break;}
case 11:
#line 165 "./src/cg2tree.y"
{
  rout << "term -> term factor\n";
  yyval.expr = new SequenceExpr(yyvsp[-1].expr, yyvsp[0].expr);
;
    break;}
case 12:
#line 170 "./src/cg2tree.y"
{
  rout << "term -> factor\n";
  yyval.expr = yyvsp[0].expr;
;
    break;}
case 13:
#line 186 "./src/cg2tree.y"
{
  rout << "factor -> symbol\n";
  if(yyvsp[-2].sym->isEmpty())
    {
      cerr << "An empty symbol (e.g. :_:) was apparently found in line " << linie << ". \nThe cause may be a missing ; after the rule before.\n";
      YYERROR;
    }
  yyvsp[-2].sym->wordforms->tags = yyvsp[0].ff->form->tags;
  yyvsp[-2].sym->baseforms->tags = yyvsp[0].ff->func->tags;
  yyval.expr = new LiteralExpr(yyvsp[-2].sym);
;
    break;}
case 14:
#line 198 "./src/cg2tree.y"
{
  rout << "factor -> symbol\n";
  if(yyvsp[0].sym->isEmpty())
    {
      cerr << "An empty symbol (e.g. :_:) was apparently found in line " << linie << ". \nThe cause may be a missing ; after the rule before.\n";
      YYERROR;
    }
  yyval.expr = new LiteralExpr(yyvsp[0].sym);
;
    break;}
case 15:
#line 208 "./src/cg2tree.y"
{
  rout << "factor -> ( regex )\n";
  yyval.expr = yyvsp[-1].expr;
;
    break;}
case 16:
#line 213 "./src/cg2tree.y"
{
  rout << "factor -> factor *\n";
  yyval.expr = new RepetitionExpr(yyvsp[-1].expr);
;
    break;}
case 17:
#line 218 "./src/cg2tree.y"
{
  rout << "factor -> factor +\n";
  RegExpr * newExpr = new RepetitionExpr(yyvsp[-1].expr);
  yyval.expr = new SequenceExpr(yyvsp[-1].expr, newExpr);
;
    break;}
case 18:
#line 224 "./src/cg2tree.y"
{
  rout << "factor -> factor ?\n";
  yyval.expr = new OptionalExpr(yyvsp[-1].expr);
;
    break;}
case 19:
#line 239 "./src/cg2tree.y"
{
  rout << "symbol -> form_and_function _ form_and_function\n";
  yyval.sym = new Symbol(yyvsp[-2].ff->func, yyvsp[-2].ff->form, yyvsp[0].ff->func, yyvsp[0].ff->form);
;
    break;}
case 20:
#line 244 "./src/cg2tree.y"
{
  rout << "symbol -> form_and_function\n";
  yyval.sym = new Symbol(yyvsp[0].ff->func, yyvsp[0].ff->form);
;
    break;}
case 21:
#line 249 "./src/cg2tree.y"
{
  rout << "symbol -> literals\n";
  yyval.sym = new Symbol(0,0,0,0, yyvsp[0].ff->form, yyvsp[0].ff->func);
;
    break;}
case 22:
#line 264 "./src/cg2tree.y"
{
  rout << "form_and_function -> tag-field : tag-field\n";
  yyval.ff = new FormAndFunc(yyvsp[-2].field, yyvsp[0].field);
;
    break;}
case 23:
#line 269 "./src/cg2tree.y"
{
  rout << "form_and_function -> tag-field\n";
  yyval.ff = new FormAndFunc(yyvsp[0].field);
;
    break;}
case 24:
#line 277 "./src/cg2tree.y"
{
  rout << "tag_field -> set_of_tags rewriter\n";
  yyval.field = new TagField(yyvsp[-1].set, *yyvsp[0].str);
;
    break;}
case 25:
#line 291 "./src/cg2tree.y"
{
  rout << "set_of_tags -> { id_list }\n";
  yyval.set = yyvsp[-1].set;
;
    break;}
case 26:
#line 296 "./src/cg2tree.y"
{
  rout << "set_of_tags -> ID(" << *yyvsp[0].str << ")\n";
  yyval.set = new StringSet();
  yyval.set->insert(*yyvsp[0].str);
;
    break;}
case 27:
#line 302 "./src/cg2tree.y"
{
  yyval.set = new StringSet();
;
    break;}
case 28:
#line 315 "./src/cg2tree.y"
{
  rout << "id_list -> ID(" << *yyvsp[-2].str << ") id_list\n";
  yyval.set = yyvsp[0].set;
  yyval.set->insert(*yyvsp[-2].str);
;
    break;}
case 29:
#line 321 "./src/cg2tree.y"
{
  rout << "id_list -> ID(" << *yyvsp[0].str << ")\n";
  yyval.set = new StringSet();
  yyval.set->insert(*yyvsp[0].str);
;
    break;}
case 30:
#line 338 "./src/cg2tree.y"
{
  rout << "literals -> { lit_list }\n";
  yyval.ff = yyvsp[-1].ff;
;
    break;}
case 31:
#line 343 "./src/cg2tree.y"
{
  rout << "literals -> string(" << *yyvsp[0].str << ")\n";
  yyval.ff = new FormAndFunc();
  yyval.ff->func->tags->insert(*yyvsp[0].str);
;
    break;}
case 32:
#line 349 "./src/cg2tree.y"
{
  rout << "literals -> string(" << *yyvsp[0].str << ")\n";
  yyval.ff = new FormAndFunc();
  yyval.ff->form->tags->insert(*yyvsp[0].str);
;
    break;}
case 33:
#line 367 "./src/cg2tree.y"
{
  rout << "lit_list -> \"" << *yyvsp[-2].str << "\" , lit_list\n";
  yyval.ff = yyvsp[0].ff;
  yyval.ff->func->tags->insert(*yyvsp[-2].str);
;
    break;}
case 34:
#line 373 "./src/cg2tree.y"
{
  rout << "lit_list -> \'" << *yyvsp[-2].str << "\' , lit_list\n";
  yyval.ff = yyvsp[0].ff;
  yyval.ff->form->tags->insert(*yyvsp[-2].str);
;
    break;}
case 35:
#line 379 "./src/cg2tree.y"
{
  rout << "lit_list -> \"" << *yyvsp[0].str << "\"\n";
  yyval.ff = new FormAndFunc();
  yyval.ff->func->tags->insert(*yyvsp[0].str);
;
    break;}
case 36:
#line 385 "./src/cg2tree.y"
{
  rout << "lit_list -> \'" << *yyvsp[0].str << "\'\n";
  yyval.ff = new FormAndFunc();
  yyval.ff->form->tags->insert(*yyvsp[0].str);
;
    break;}
case 37:
#line 400 "./src/cg2tree.y"
{
  rout << "rewriter -> [-> ID(" << *yyvsp[-1].str << ") ]\n";
  yyval.str = yyvsp[-1].str;
;
    break;}
case 38:
#line 405 "./src/cg2tree.y"
{
  yyval.str = new string(""); 
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 410 "./src/cg2tree.y"


void usage()
{
  cout << "Usage: cg2tree [options] grammar_file\n"
    "        Read cg output from stdin and try to compose\n"
    "        tree structures by following the rules\n"
    "        specified in grammar_file. All successfully\n"
    "        constructed trees are by default printed to\n"
    "        stdout in VISL format.\n\n"
    "Options:\n"
    //    "  -c          Generate source code for a static grammar.\n"
    "  -C          Print complete trees as soon as they are found.\n"
    "  -b          Don't attempt to build any trees.\n"
    "              Exit after printing the compiled rule set\n"
    "              and input tokens.\n"
    "  -dn         Turn on debugging output.\n"
    "              n specifies a debug level to turn on.\n"
    "              If n is unspecified or 0, level 1 is assumed.\n"
    "  -h          Print this help text and exit.\n"
    "  -I          Print incompletable states as soon as they are found.\n"
    "  -r          Print all reductions made when parsing the grammar file.\n"
    "  -s          Print some statistics.\n"
    "  -S          Print each state visited during compilation.\n"
    "  -t          Suppress output of VISL trees.\n"
    "  -T          For each complete tree, print the sequence\n"
    "              of rules used to build it.\n"
    "  -x          Use experimental algorithm.\n"
    ;
}

int main(int argc, char * argv[])
{
  parse = 1;
  code = 0;
  experimental = 0;
  debugLevel = 0;
  printComplete = 0;
  printIncompletable = 0;
  printAllStates = 0;
  reduce = 0;
  tree = 1;
  tracking = 0;
  statistics = 0;
  if(argc<=1)
    {
      usage();
      return 1;
    }
  for(int i=1; i<argc-1; i++)
    {
      if(argv[i][0] == '-')
	{
	  switch(argv[i][1])
	    {
	    case 'd': /* debug output on */
	      if(argv[i][2]==0)
		{
		  cerr << "-d : missing argument. Assuming level 1.\n";
		  debugLevel |= 1;
		  cerr << "Debug level = " << debugLevel << "\n";
		}
	      else
		{
		  debugLevel |= argv[i][2] - '0';
		  cerr << "Debug level = " << debugLevel << "\n";
		}
	      break;
	    case 'c': /* generate compiler-source */
	      cerr << "warning: code generation not implemented (-c)\n";
	      code = 1;
	      break;
	    case 'r': /* reductions output on */
	      reduce = 1;
	      break;
	    case 'b': /* don't build. quit after compiling rules and tokens */
	      parse = 0;
	      debugLevel |= 1;
	      break;
	    case 'C': /* list all complete trees as they are found */
	      printComplete = 1;
	      break;
	    case 'h': /* print help text */
	      usage();
	      return 0;
	    case 'I': /* list all incomplete trees as they are found */
	      printIncompletable = 1;
	      break;
	    case 's': /* print "profiling" statistics */
	      statistics = 1;
	      break;
	    case 'S': /* print all states visited. */
	      printAllStates = 1;
	      break;
	    case 'T': /* track state history */
	      tracking = 1;
	      break;
	    case 't': /* don't output VISL trees. */
	      tree = 0;
	      break;
	    case 'x': /* use experimental algorithm. */
	      experimental = 1;
	      break;
	    default:
	      cout << "Unknown option " << argv[i] << "\n";
	      usage();
	      return 1;
	    }
	} 
      else 
	{
	  usage();
	  return 1;
	}
    }
  // set input source of lexer.
  yyin = fopen(argv[argc-1], "r" );
  if(yyin==NULL)
    {
      cout << "Could not open file " << argv[argc-1] <<"\n";
      return 1;
    }
  debug(1) << "Compiled Rules:\n";
  if(!yyparse())
    {
      Token * t = 0;
      Token * prev = 0;
      Token * last = 0;
      output= new TokenString();
      debug(1) << "\nInput Tokens:\n";
      while((t = readToken(prev)))
	{
	  debug(1) << t->toString() << "\n";
	  prev = t;
	}
      if(parse)
	{
	  doParse(prev);
	}
      if(statistics)
	{
	  cout << rules->size() << " rules.\n";
	  cout << synonyms->size() << " synonym definitions.\n";
	  cout << input->size() << " input tokens.\n";
	  cout << output->size() << " output trees.\n";
	  cout << "Tokens created: "<<Token::constructorInvoked<<"\n";
	  cout << "Token::appendMatches invoked "<<Token::appendMatchesInvoked<<" times.\n";
	  cout << "Rule::match invoked "<<Rule::matchInvoked<<" times.\n";
	  cout << "RegExpr::match invoked "<<RegExpr::matchInvoked<<" times.\n";
	}
    }
  else
    {
      cout << "Failed to parse rules!\n";
    }
}
